function [time pBPM] = compute_pulse(ppg,Fs,pMin)%,wL, wD, pMin, pMax)

% FUNCTION compute_pulse(ppg,Fs,wL, wD, pMin, pMax)
% ppg:  ppg or similar signal containing heart rate pulsations
% Fs:   sampling rate in samples per second
% wL:   window length in seconds
% wD:   window displacement in samples
% pMin: minimum pulse frequency in bpm
% pMax: maximum pulse frequency in bpm

wL=12;
wD=Fs;
% pMin=45;
pMax=200;

wL=wL*Fs;
w=hamming(wL);
% w=ones(wL,1);
wN=round((length(ppg)-wL)/wD);
fN=Fs*60*5;
pMin=round(pMin*fN/Fs/60);
pMax=round(pMax*fN/Fs/60);
pI=zeros(1,wN);

for ii=1:wN
    start=wD*(ii-1)+1;
    stop=start+wL-1;
    ppgSegmentWindowed=stdnrm(stdnrm(ppg(start:stop)).*w');
    ppgSegmentPSD=abs(fft(ppgSegmentWindowed,fN)).^2;
    ppgSegmentPSD([1:pMin pMax:end])=0;
    [~,pI(ii)]=max(ppgSegmentPSD);
    if ii>1
        while pI(ii)>1.1*pI(ii-1)||pI(ii)<.9*pI(ii-1)
            ppgSegmentPSD(pI(ii))=0;
            [~,pI(ii)]=max(ppgSegmentPSD);
        end
    end
end

pBPM=pI*Fs*60/fN;
% time=linspace(0,Fs*length(pBPM)/wD,length(pBPM));
time=.01*round(100*linspace(wL/Fs,wL/Fs+Fs*length(pBPM)/wD,length(pBPM)));

