%% Extract the G channel for each square in a grid

% clear all
% close all force
FILENAME = 'C:\Users\asmundr\Videos\01\01crop.avi';
OBJ = VideoReader(FILENAME);

numFrames = get(OBJ, 'NumberOfFrames');
% disp(numFrames)
frame1 = read(OBJ,1);
res=size(frame1);
yres=res(1);
xres=res(2);

image(frame1)
axis equal
hold on

dx=4; % x-dim of square
dy=4; % y-dim of square
numBlocks=xres*yres/(dx*dy);

% create vector of square coordinates on form
% [x-pos top left, y-pos top left, dx, dy]
b=zeros(4,numBlocks);
b(1,:)=mod(1:dx:dx*numBlocks,xres);
b(2,:)=sort(mod(1:dy:dy*numBlocks,yres));
b(3,:)=dx*ones(1,numBlocks);
b(4,:)=dy*ones(1,numBlocks);

% display grid on video frame
for ii=1:numBlocks
rectangle('position',b(:,ii),'edgecolor','g')
end
hold off

%% Average pixel value for each square and each frame
R=zeros(numBlocks,numFrames);
G=zeros(numBlocks,numFrames);
B=zeros(numBlocks,numFrames);
h = waitbar(0,'Please wait...');
for ii=1:numFrames
    waitbar(ii/numFrames,h)
    frameii=read(OBJ,ii);
    for jj=1:numBlocks
        rect=frameii(b(2,jj):b(2,jj)+dy-1,b(1,jj):b(1,jj)+dx-1,1);
        R(jj,ii)=sum(sum(rect))/(dx*dy);
        rect=frameii(b(2,jj):b(2,jj)+dy-1,b(1,jj):b(1,jj)+dx-1,2);
        G(jj,ii)=sum(sum(rect))/(dx*dy);
        rect=frameii(b(2,jj):b(2,jj)+dy-1,b(1,jj):b(1,jj)+dx-1,3);
        B(jj,ii)=sum(sum(rect))/(dx*dy);
    end
end
for ii=1:numBlocks, G(ii,:)=zmean(G(ii,:)); end
save('01crop4x4rgb.mat','G','R','B')
close all force
        
        
        
        
        
        
        
        
        
        
        
        