% clc
% clear all,close all force

% Doing face recognition on each frame and storing coordinates

FILENAME = 'facevid.avi';
OBJ = VideoReader(FILENAME);

numFrames = get(OBJ, 'NumberOfFrames');
disp(numFrames);

h = waitbar(0,'Please wait...');
noface=zeros(1,numFrames);
Face=zeros(4,numFrames);
RGB=zeros(3,numFrames);

for k = 1 : numFrames, waitbar(k/numFrames,h)
    
    % Read frame, recognize face, make sure everything is ok or else using
    % coordinates from previous frame.
    A = read(OBJ,k);
    Img = double (rgb2gray(A));
    AFace = FaceDetect('haarcascade_frontalface_alt2.xml',Img);clear Img
    if all(size(AFace)==[1 4])
        Face(:,k)=AFace;
    elseif all(size(AFace)==[2 4])
            d1=abs(AFace(1,1)-Face(1,k-1));
            d2=abs(AFace(2,1)-Face(1,k-1));
            if d1<=d2, Face(:,k)=AFace(1,:);
            else
                Face(:,k)=AFace(2,:);
            end
    elseif all(size(AFace)==[3 4])
            d1=abs(AFace(1,1)-Face(1,k-1));
            d2=abs(AFace(2,1)-Face(1,k-1));
            d3=abs(AFace(3,1)-Face(1,k-1));
            if d1<=d2&&d1<=d3, Face(:,k)=AFace(1,:);
            elseif d2<=d1&&d2<=d3, Face(:,k)=AFace(2,:);
            else
                Face(:,k)=AFace(3,:);
            end
    else
        Face(:,k)=Face(:,k-1);
        noface(k)=1;
    end
    clear AFace
    
    % Reducing width of face rectangle by 40%
    reduceWidthBy=.4*Face(3,k);
    Face(1,k)=round(Face(1,k)+.5*reduceWidthBy);
    Face(3,k)=round(Face(3,k)-reduceWidthBy);
    
    % Extracting RGB averages
    f1=Face(1,k);f2=Face(2,k);f3=Face(3,k);f4=Face(4,k);
    for ii=1:3
        RGB(ii,k)=(1/(f3*f4))*sum(sum(A(f2:f2+f4,f1:f1+f3,ii)));
    end
    
% %     Plotting video frame with green rectangle indicating recognized
% %     face
%     Rectangle = [...
%         f1 f2;...
%         f1+f3 f2;...
%         f1+f3 f2+f4;...
%         f1  f2+f4;...
%         f1 f2];
% 
%     figure(1);
%     imshow (A);
%     truesize;
%     hold on;
%     plot (Rectangle(:,1), Rectangle(:,2), 'g');
%     hold off;pause
end

close all force
save('facevid.mat','RGB', 'Face', 'noface')