clear all, close all force
load facevid Face RGB

FILENAME = 'facevid.avi';
OBJ = VideoReader(FILENAME);

numFrames = get(OBJ, 'NumberOfFrames');
disp(numFrames);

h = waitbar(0,'Please wait...');
RGB=zeros(3,numFrames);

% Using previously recognized face coordinates, extracting RGB averages
% from top middle segment with dimensions Face(3,k) x Face(4,k)
for k = 1:numFrames, waitbar(k/numFrames,h)
    
    A = read(OBJ,k);
    Face(1,k)=Face(1,k)+round((Face(3,k)-64)/2);
    Face(3,k)=64;
    Face(4,k)=32;
    f1=Face(1,k);f2=Face(2,k);f3=Face(3,k);f4=Face(4,k);
    for ii=1:3
        RGB(ii,k)=(1/(f3*f4))*sum(sum(A(f2:f2+f4,f1:f1+f3,ii)));
    end
    
%     Rectangle = [...
%         Face(1,k) Face(2,k);...
%         Face(1,k)+Face(3,k) Face(2,k);...
%         Face(1,k)+Face(3,k) Face(2,k)+Face(4,k);...
%         Face(1,k)  Face(2,k)+Face(4,k);...
%         Face(1,k) Face(2,k)];
% 
%     figure(1);
%     imshow (A);
%     truesize;
%     hold on;
%     plot (Rectangle(:,1), Rectangle(:,2), 'g');
%     hold off;pause
end

close all force
save('forehead64x32.mat','RGB', 'Face')