% Extracts R(t), G(t), B(t) by averaging the pixel value over each frame
% for each channel.

FILENAME = 'C:\Users\asmundr\Videos\webcam.avi';
OBJ = VideoReader(FILENAME);

numFrames = get(OBJ, 'NumberOfFrames');
disp(numFrames);
vidFrames = read(OBJ,1);
res=size(vidFrames);
fac=res(1)*res(2);

h = waitbar(0,'Please wait...');
R=zeros(1,numFrames);
G=zeros(1,numFrames);
B=zeros(1,numFrames);

for k = 1 : numFrames
    waitbar(k/numFrames,h)
    vidFrames = read(OBJ,k);
    R(k) = sum(sum(vidFrames(:,:,1)))/fac;
    G(k) = sum(sum(vidFrames(:,:,2)))/fac;
    B(k) = sum(sum(vidFrames(:,:,3)))/fac;
end


close all force
save('webcam.mat','R','G','B')