%-------------------------------------------------
load 01crop4x4rgb.mat

Gd=zeros(size(G));
for ii=1:size(G,1)
    Gd(ii,:)=limitdiff(G(ii,:));
end
G=Gd;

%compute PSDs
N=2^nextpow2(length(G));
GF=abs(fft(G',N)).^2/N;
GF=GF(1:N/2,:);
idx28bpm=round(28*N/(2*15*60));
idx200bpm=round(200*N/(2*15*60));%2*15*60*71/N
GF(1:idx28bpm,:)=0;
GF(idx200bpm:end,:)=0;
f=linspace(0,15*60,N/2);


%find peaks
for ii=1:size(G,1)
    [Y(ii) I(ii)]=max(GF(:,ii));
end

Icorrectpulse=find(I==mode(I));
Iwrongpulse=find(I~=mode(I));
Y(Iwrongpulse)=0;
Ibest=find(Y>3*std(Y));     % red squares
Igood=find(Y>2*std(Y));     % yellow squares
Iok=find(Y>std(Y));         % green squares
Ilessok=find(Y>.5*std(Y));  % blue squares
% figure,plot(Y)
% figure,hist(Y)


GZ=stdnrm(sum(G(Ibest,:))); % summing best signals
figure,plotbands(stdnrm(double(GZ)),'k')
myspectrogram(double(GZ),30,'log')
% plot(G(145,:))


% show previously computed image averaged over all frames to indicate
% video is not completely stable
load hand7c_averageimage
frame1 = frameaverage;
res=size(frame1);
yres=res(1);
xres=res(2);
figure
imagesc(frame1)
axis equal
hold on
dx=8;
dy=8;
numBlocks=xres*yres/(dx*dy);

b=zeros(4,numBlocks);
b(1,:)=mod(1:dx:dx*numBlocks,xres);
b(2,:)=sort(mod(1:dy:dy*numBlocks,yres));
b(3,:)=dx*ones(1,numBlocks);
b(4,:)=dy*ones(1,numBlocks);

% display colored squares overlayed video frame:

for ii=Ilessok    
rectangle('position',b(:,ii),'facecolor','b')
end

for ii=Iok    
rectangle('position',b(:,ii),'facecolor','g')
end

for ii=Igood    
rectangle('position',b(:,ii),'facecolor','y')
end

for ii=Ibest   
rectangle('position',b(:,ii),'facecolor','r')
end

hold off

% load('hand7cc.mat')
% myspectrogram(limitdiff(G),30,'log')
% figure,plotbands(stdnrm(double(G)),'k')




