function outvec = limitdiff(invec)

% Function to remove "discontinuities" in a vector by removing peaks in
% the differential over 3 times its own standard deviation.

diffvec=diff(invec);
stdev=sqrt(var(diffvec));
diffvec(abs(diffvec)>3*stdev)=0;
outvec=cumsum(diffvec-mean(diffvec));
outvec=[outvec(1) outvec];

end